routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::resource('offer', 'OfferController');
Route::resource('beneficiary', 'BeneficiaryController');

app/Beneficiary.php
<?php



namespace App;



use Illuminate\Database\Eloquent\Model;



class Beneficiary extends Model

{

    protected $fillable = [



            'name',

            'surname',

            'dni',

            'birthday',

            'adress',

            'phone',

            'email'

    ];

    protected $dates =[

        'birthday'

    ];



    public function getDateForInput(){

        return $this->birthday->format('Y-m-d');

    }

}

app/Offer.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Offer extends Model
{
    protected $fillable = [

        'title',
            'description',
            'location',
            'agreementType',
            'quantity',
            'limitDate',
            'beneficiary',
            'companyOffer'
    ];
 /*    {{ \Carbon\Carbon::parse($user->limitDate)->format('d/m/Y')}} */
    protected $dates =[
        'limitDate'
    ];
   /*  protected $dateFormat = 'U'; */

   /* ->format('d \d\e M \d\e\l Y') */

    public function getDateForInput(){
        return $this->limitDate->format('Y-m-d');
    }
}

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/BeneficiaryController.php
<?php



namespace App\Http\Controllers;



use App\Beneficiary;

use Illuminate\Http\Request;



class BeneficiaryController extends Controller

{

    /**

     * Display a listing of the resource.

     *

     * @return \Illuminate\Http\Response

     */

    public function index()

    {

        $beneficiaries=Beneficiary::all();

        return view('beneficiary.index',compact('beneficiaries'));

    }

    /**

     * Show the form for creating a new resource.

     *

     * @return \Illuminate\Http\Response

     */

    public function create()

    {

        return view('beneficiary.create');

    }



    /**

     * Store a newly created resource in storage.

     *

     * @param  \Illuminate\Http\Request  $request

     * @return \Illuminate\Http\Response

     */

    public function store(Request $request)

    {

        $beneficiary=new Beneficiary([

            'name'=>$request->get('name'),

            'surname'=>$request->get('surname'),

            'dni'=>$request->get('dni'),

            'birthday'=>$request->get('birthday'),

            'adress'=>$request->get('adress'),

            'phone'=>$request->get('phone'),

            'email'=>$request->get('email'),

        ]);

        $beneficiary->save();

        return redirect('/beneficiary')->with('success','Beneficiary saved!');

    }

    



    /**

     * Display the specified resource.

     *

     * @param  \App\Beneficiary  $beneficiary

     * @return \Illuminate\Http\Response

     */

    public function show(Beneficiary $beneficiary)

    {

        //

    }



    /**

     * Show the form for editing the specified resource.

     *

     * @param  \App\Beneficiary  $beneficiary

     * @return \Illuminate\Http\Response

     */

    public function edit($id)

    {

        $beneficiary = Beneficiary::find($id);

        return view('beneficiary.edit', compact('beneficiary'));

    }



    /**

     * Update the specified resource in storage.

     *

     * @param  \Illuminate\Http\Request  $request

     * @param  \App\Beneficiary  $beneficiary

     * @return \Illuminate\Http\Response

     */

    public function update(Request $request, Beneficiary $beneficiary)

    {

        $beneficiary->update($request->all());

        return redirect('/beneficiary')->with('success', 'Beneficiary updated!');

    }



    /**

     * Remove the specified resource from storage.

     *

     * @param  \App\Beneficiary  $beneficiary

     * @return \Illuminate\Http\Response

     */

    public function destroy(Beneficiary $beneficiary)

    {

        $beneficiary->delete();

        return redirect('/beneficiary')->with('success', 'Beneficiary deleted!');

    }

}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/OfferController.php
<?php



namespace App\Http\Controllers;



use App\Offer;

use Illuminate\Http\Request;



class OfferController extends Controller

{

    /**

     * Display a listing of the resource.

     *

     * @return \Illuminate\Http\Response

     */

    public function index()

    {

        $offers=Offer::all();

        return view('offer.index',compact('offers'));

    }



    /**

     * Show the form for creating a new resource.

     *

     * @return \Illuminate\Http\Response

     */

    public function create()

    {

        return view('offer.create');

    }



    /**

     * Store a newly created resource in storage.

     *

     * @param  \Illuminate\Http\Request  $request

     * @return \Illuminate\Http\Response

     */

    public function store(Request $request)

    {

        $offer=new Offer([

            'title'=>$request->get('title'),

            'description'=>$request->get('description'),

            'location'=>$request->get('location'),

            'agreementType'=>$request->get('agreementType'),

            'quantity'=>$request->get('quantity'),

            'limitDate'=>$request->get('limitDate'),

            'beneficiary'=>$request->get('beneficiary'),

            'companyOffer'=>$request->get('companyOffer'),

        ]);

        $offer->save();

        return redirect('/offer')->with('success','Offer saved!');

    }



    /**

     * Display the specified resource.

     *

     * @param  \App\Offer  $offer

     * @return \Illuminate\Http\Response

     */

    public function show(Offer $offer)

    {

        return response()->json($offer);

    }



    /**

     * Show the form for editing the specified resource.

     *

     * @param  \App\Offer  $offer

     * @return \Illuminate\Http\Response

     */

    public function edit($id)

    {

        $offer = Offer::find($id);

        return view('offer.edit', compact('offer'));

    }



    /**

     * Update the specified resource in storage.

     *

     * @param  \Illuminate\Http\Request  $request

     * @param  \App\Offer  $offer

     * @return \Illuminate\Http\Response

     */

    public function update(Request $request, Offer $offer)

    {

        $request->validate([

            'title'=>'required',

            'description'=>'required',

            'location'=>'required'

        ]);

        

        $offer->update($request->all());

        return redirect('/offer')->with('success', 'Offer updated!');

    }



    /**

     * Remove the specified resource from storage.

     *

     * @param  \App\Offer  $offer

     * @return \Illuminate\Http\Response

     */

    public function destroy(Offer $offer)

    {

        $offer->delete();

        return redirect('/offer')->with('success', 'Contact deleted!');

    }

}

resources/views/base.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Backend F5</title>
    <link href="{{ asset('css/app.css' )}}" rel="stylesheet" type="text/css" />
</head>
<body>
    <div class="container-fluid">
        <div class="logo">
        <span><img src="http://www.bancderecursos.org/wp-content/uploads/icona_logo.png" width="300px" class="float-left" alt="logo"></span>
        </div>
        
        @yield('main')
        
        
    </div>
    <script src="{{ asset('js/app.js') }}" type="text/js"></script>
    
</body>
</html>

resources/views/beneficiary/create.blade.php
@extends('base')

@section('main')

<div class="row">
        <div class="col-sm-8 offset-sm-2">
                <h1 class="display-3 mgtop">Afegir un candidat</h1>
                <div>
                  @if ($errors->any())
                    <div class="alert alert-danger">
                      <ul>
                          @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                          @endforeach
                      </ul>
                    </div><br />
                    @endif

    <form method="post" action="{{route('beneficiary.store')}}">
    @csrf
    <div class="form-group"><label for="name">Nom</label><input class="form-control" type="text"            name="name">
    </div>
    <div class="form-group"><label for="surname">Cognoms</label><input class="form-control" type="text"     name="surname">
    </div>
    <div class="form-group"><label for="dni">DNI</label><input class="form-control" type="char"             name="dni">
    </div>
    <div class="form-group"><label for="birthday">Aniversari</label><input class="form-control" type="date"   name="birthday">
    </div>
    <div class="form-group"><label for="adress">Adreça</label><input class="form-control" type="text"       name="adress">
    </div>
    <div class="form-group"><label for="phone">Telèfon</label><input class="form-control" type="integer"      name="phone">
    </div>
    <div class="form-group"><label for="email">Email</label><input class="form-control" type="text"         name="email">
    </div>
    <button type="submit" class="btn btn-primary-outline">Afegir candidat</button>
    </form>
@endsection

resources/views/beneficiary/edit.blade.php
@extends('base') 

@section('main')
<div class="row">
    <div class="col-sm-8 offset-sm-2">
        <h1 class="display-3 mgtop">Editar un candidat</h1>

        @if ($errors->any())
        <div class="alert alert-danger">
            <ul>
                @foreach ($errors->all() as $error)
                <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
        <br /> 
        @endif
        <form method="post" action="{{ route('beneficiary.update', $beneficiary->id) }}">
            @method('PATCH') 
            @csrf
            <div class="form-group"><label for="name">Nom</label><input class="form-control" type="text"    name="name" value="{{ $beneficiary->name }}">
            </div>
            <div class="form-group"><label for="surname">Cognoms</label><input class="form-control"         type="text" name="surname" value="{{ $beneficiary->surname }}">
            </div>
            <div class="form-group"><label for="dni">DNI</label><input class="form-control" type="char"     name="dni" value="{{ $beneficiary->dni }}"></div>
            <div class="form-group"><label for="birthday">Aniversari</label><input class="form-control"     type="date" name="birthday" value="{{ $beneficiary->getDateForInput() }}">
            </div>
            <div class="form-group"><label for="adress">Adreça</label><input class="form-control"           type="text" name="adress" value="{{ $beneficiary->adress }}">
            </div>
            <div class="form-group"><label for="phone">Telèfon</label><input class="form-control"           type="integer" name="phone" value="{{ $beneficiary->phone }}">
            </div>
            <div class="form-group"><label for="email">Email</label><input class="form-control"             type="text" name="email" value="{{ $beneficiary->email }}">
            </div>
            <button type="submit" class="btn btn-primary">Editar</button>
        </form>
    </div>
</div>
@endsection

resources/views/beneficiary/index.blade.php
@extends('base')

@section('main')
<div class="row">
    <div class="col-sm-12">
        <h1 class="display-3 mgtop">Candidats</h1>
        <div>
            <a style="margin: 19px;" href="{{ route('beneficiary.create')}}" class="btn btn-primary">Nou candidat</a>
        </div>     
      <table class="table table-striped">
        <thead>
            <tr>
                <td>Nom</td>
                <td>Cognoms</td>
                <td>DNI</td>
                <td>Aniversari</td>
                <td>Adreça</td>
                <td>Telèfon</td>
                <td>Email</td>
                <td colspan = 2>Accions</td>
            </tr>
        </thead>
        <div class="col-sm-12">
    
                @if(session()->get('success'))
                  <div class="alert alert-success">
                    {{ session()->get('success') }}  
                  </div>
                @endif
              </div>
        <tbody>
        @foreach($beneficiaries as $beneficiary)
            <tr>
                <td>{{$beneficiary->name}}</td>
                <td>{{$beneficiary->surname}}</td>
                <td>{{$beneficiary->dni}}</td>
                <td>{{$beneficiary->birthday->format('d/m/Y')}}</td>
                <td>{{$beneficiary->adress}}</td>
                <td>{{$beneficiary->phone}}</td>
                <td>{{$beneficiary->email}}</td>
                <td>
                    <a href="{{ route('beneficiary.edit',$beneficiary->id)}}" class="btn btn-primary">Editar</a>
                </td>
                <td>
                    <form action="{{ route('beneficiary.destroy', $beneficiary->id)}}" method="post">
                      @csrf
                      @method('DELETE')
                      <button class="btn btn-danger" type="submit">Esborrar</button>
                    </form>
                </td>
            </tr>
        @endforeach
        </tbody>
    </table>
    <div>
    </div>
@endsection

resources/views/index.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <title>Laravel</title>

        <!-- Fonts -->
        <link href="https://fonts.googleapis.com/css?family=Nunito:200,600" rel="stylesheet">

        <!-- Styles -->
        <style>
            html, body {
                background-color: #fff;
                color: #636b6f;
                font-family: 'Nunito', sans-serif;
                font-weight: 200;
                height: 100vh;
                margin: 0;
            }

            .full-height {
                height: 100vh;
            }

            .flex-center {
                align-items: center;
                display: flex;
                justify-content: center;
            }

            .position-ref {
                position: relative;
            }

            .top-right {
                position: absolute;
                right: 10px;
                top: 18px;
            }

            .content {
                text-align: center;
            }

            .title {
                font-size: 84px;
            }

            .links > a {
                color: #636b6f;
                padding: 0 25px;
                font-size: 13px;
                font-weight: 600;
                letter-spacing: .1rem;
                text-decoration: none;
                text-transform: uppercase;
            }

            .m-b-md {
                margin-bottom: 30px;
            }
        </style>
    </head>
    <body>
        <div class="flex-center position-ref full-height">
            @if (Route::has('login'))
                <div class="top-right links">
                    @auth
                        <a href="{{ url('/home') }}">Home</a>
                    @else
                        <a href="{{ route('login') }}">Login</a>

                        @if (Route::has('register'))
                            <a href="{{ route('register') }}">Register</a>
                        @endif
                    @endauth
                </div>
            @endif

            <div class="content">
                <div class="title m-b-md">
                    Laravel
                </div>

                <div class="links">
                    <a href="https://laravel.com/docs">Docs</a>
                    <a href="https://laracasts.com">Laracasts</a>
                    <a href="https://laravel-news.com">News</a>
                    <a href="https://blog.laravel.com">Blog</a>
                    <a href="https://nova.laravel.com">Nova</a>
                    <a href="https://forge.laravel.com">Forge</a>
                    <a href="https://github.com/laravel/laravel">GitHub</a>
                </div>
            </div>
        </div>
    </body>
</html>

resources/views/offer/create.blade.php
@extends('base')

@section('main')

<div class="row">
        <div class="col-sm-8 offset-sm-2">
                <h1 class="display-3 mgtop">Afegir una oferta</h1>
                <div>
                  @if ($errors->any())
                    <div class="alert alert-danger">
                      <ul>
                          @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                          @endforeach
                      </ul>
                    </div><br />
                    @endif

    <form method="post" action="{{route('offer.store')}}">
    @csrf
    <div class="form-group"><label for="title">Títol</label><input class="form-control" type="text"         name="title">
    </div>
    <div class="form-group"><label for="companyOffer">Empresa</label><input class="form-control"            type="text" name="companyOffer">
    </div>
    <div class="form-group"><label for="description">Descripció</label><input class="form-control"          type="text" name="description">
    </div>
    <div class="form-group"><label for="location">Lloc</label><input class="form-control" type="text"       name="location">
    </div>
    <div class="form-group"><label for="agreementType">Tipus de conveni</label><input                       class="form-control" type="text" name="agreementType">
    </div>
    <div class="form-group"><label for="quantity">Quantitat d'operaris</label><input class="form-control"   type="number" name="quantity">
    </div>
    <div class="form-group"><label for="limitDate">Data</label><input class="form-control"             type="date" name="limitDate">
    </div>
    <div class="form-group"><label for="beneficiary">Contractats</label><input class="form-control"         type="text" name="beneficiary">
    </div>
    <button type="submit" class="btn btn-primary-outline">Afegir oferta</button>
    </form>
@endsection

resources/views/offer/edit.blade.php
@extends('base') 

@section('main')
<div class="row">
    <div class="col-sm-8 offset-sm-2">
        <h1 class="display-3 mgtop">Editar una oferta</h1>

        @if ($errors->any())
        <div class="alert alert-danger">
            <ul>
                @foreach ($errors->all() as $error)
                <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
        <br /> 
        @endif
    
        <form method="post" action="{{ route('offer.update', $offer->id) }}">
            @method('PATCH') 
            @csrf
            <div class="form-group"><label for="title">Títol</label><input class="form-control"             type="text" name="title" value="{{ $offer->title }}">
            </div>
            <div class="form-group"><label for="companyOffer">Empresa</label><input class="form-control"    type="text" name="companyOffer" value="{{ $offer->companyOffer }}">
            </div>
            <div class="form-group"><label for="description">Descripció</label><input                       class="form-control" type="text" name="description" value="{{ $offer->description }}">
            </div>
            <div class="form-group"><label for="location">Lloc</label><input class="form-control"           type="text" name="location" value="{{ $offer->location }}">
            </div>
            <div class="form-group"><label for="agreementType">Tipus de conveni</label><input               class="form-control" type="text" name="agreementType" value="{{ $offer->agreementType }}">
            </div>
            <div class="form-group"><label for="quantity">Quantitat d'operaris</label><input                class="form-control" type="number" name="quantity" value="{{ $offer->quantity }}">
            </div>
            <div class="form-group"><label for="limitDate">Data</label><input class="form-control"          type="date" name="limitDate" value="{{ $offer->getDateForInput() }}">
            </div>
            <div class="form-group"><label for="beneficiary">Contactats</label><input                       class="form-control" type="text" name="beneficiary" value="{{ $offer->beneficiary }}">
            </div>
            <button type="submit" class="btn btn-primary">Editar</button>
        </form>
    </div>
</div>
@endsection

resources/views/offer/index.blade.php
@extends('base')

@section('main')
<div class="row">
    <div class="col-sm-12">
        <h1 class="display-3 mgtop">Ofertes</h1>
        <div>
            <a style="margin: 19px;" href="{{ route('offer.create')}}" class="btn btn-primary">Nova oferta</a>
        </div>     
      <table class="table table-striped">
        <thead>
            <tr>
                <td>Títol</td>
                <td>Empresa</td>
                <td>Descripció</td>
                <td>Lloc</td>
                <td>Tipus de conveni</td>
                <td>Quantitat d'operaris</td>
                <td>Data</td>
                <td>Contractats</td>
                <td colspan = 2>Accions</td>
            </tr>
        </thead>
        <div class="col-sm-12">
    
                @if(session()->get('success'))
                  <div class="alert alert-success">
                    {{ session()->get('success') }}  
                  </div>
                @endif
              </div>
        <tbody>
        @foreach($offers as $offer)
            <tr>
                <td>{{$offer->title}}</td>
                <td>{{$offer->companyOffer}}</td>
                <td>{{$offer->description}}</td>
                <td>{{$offer->location}}</td>
                <td>{{$offer->agreementType}}</td>
                <td>{{$offer->quantity}}</td>
                <td>{{$offer->limitDate->format('d/m/Y')}}</td>
                <td>{{$offer->beneficiary}}</td>
                <td>
                    <a href="{{ route('offer.edit',$offer->id)}}" class="btn btn-primary">Editar</a>
                </td>
                <td>
                    <form action="{{ route('offer.destroy', $offer->id)}}" method="post">
                      @csrf
                      @method('DELETE')
                      <button class="btn btn-danger" type="submit">Esborrar</button>
                    </form>
                </td>
            </tr>
        @endforeach
        </tbody>
    </table>
    <div>
    </div>
@endsection